/**
 * @file
 * Script for the mediaflow image/video selector
 */
(function ($) {
  "use strict";

  $.fn.mediaFlowBrowser = function () {
    this.each(function () {
      var settings = {};
      var container = $(this);
      var fileSelector;
      $.extend(settings, drupalSettings.mediaflow);
      $.extend(settings, {
        success: function(response) {
          $('[data-mediaflow-target]')
            .val(JSON.stringify(response))
            .trigger('change');
          $('[data-drupal-selector="edit-submit"]').click();
        },
      });
      fileSelector = new FileSelector(container.attr('id'), settings);
      $('[data-drupal-selector="edit-submit"]').hide();
    });
  }

  Drupal.behaviors.mediaFlowSelector = {
    attach: function (context) {
      $('[data-mediaflow-selector]', context).once('mediaflow').mediaFlowBrowser();
    }
  }

})(jQuery);
